Index: zm_image.cpp
===================================================================
--- zm_image.cpp	(revision 2859)
+++ zm_image.cpp	(working copy)
@@ -295,7 +295,7 @@
 		return( false );
 	}
 
-	if ( fwrite( buffer, size, 1, outfile ) < 1 )
+	if ( fwrite( buffer, size, 1, outfile ) != 1 )
     {
         Error( "Unable to write to '%s': %s", filename, strerror(errno) );
         return( false );
Index: zm_event.cpp
===================================================================
--- zm_event.cpp	(revision 2859)
+++ zm_event.cpp	(working copy)
@@ -1235,7 +1235,7 @@
                 break;
         }
         fprintf( stdout, "Content-Length: %d\r\n\r\n", img_buffer_size );
-        if ( fwrite( img_buffer, img_buffer_size, 1, stdout ) < 0 )
+        if ( fwrite( img_buffer, img_buffer_size, 1, stdout ) != 1 )
         {
             Error( "Unable to send stream frame: %s", strerror(errno) );
             return( false );
Index: zm_monitor.cpp
===================================================================
--- zm_monitor.cpp	(revision 2859)
+++ zm_monitor.cpp	(working copy)
@@ -3231,7 +3231,7 @@
         fprintf( stdout, "--ZoneMinderFrame\r\n" );
         fprintf( stdout, "Content-Length: %d\r\n", img_buffer_size );
         fprintf( stdout, "Content-Type: image/jpeg\r\n\r\n" );
-        if ( fwrite( img_buffer, img_buffer_size, 1, stdout ) < 0 )
+        if ( fwrite( img_buffer, img_buffer_size, 1, stdout ) != 1 )
         {
             Error( "Unable to send stream frame: %s", strerror(errno) );
             return( false );
@@ -3316,7 +3316,7 @@
                 break;
         }
         fprintf( stdout, "Content-Length: %d\r\n\r\n", img_buffer_size );
-        if ( fwrite( img_buffer, img_buffer_size, 1, stdout ) < 0 )
+        if ( fwrite( img_buffer, img_buffer_size, 1, stdout ) != 1 )
         {
             Error( "Unable to send stream frame: %s", strerror(errno) );
             return( false );
@@ -3401,7 +3401,7 @@
             Debug( 2, "Assigned temporary buffer" );
         }
     }
-
+	float max_secs_since_last_sent_frame = 10; //should be > keep alive amount (5 secs)
 	while ( !zm_terminate )
 	{
         bool got_command = false;
@@ -3575,6 +3575,12 @@
                 break;
             }
         }
+		if (TV_2_FLOAT( now ) - last_frame_sent > max_secs_since_last_sent_frame)
+		{
+			Error( "Killing myself off as have exceeded max_secs_since_last_sent_frame of %f (max %f)", TV_2_FLOAT( now ) - last_frame_sent, max_secs_since_last_sent_frame );
+			break;
+		}
 	}
     if ( buffered_playback )
     {
